/*
        include file nbstime.h

        this file is used to define the constants
        that govern the compilation of program NBSTIME.

        if the constant IBMPC is defined then the
        program is intended to run on an IBM-PC
        (or equivalent machine) under MSDOS.

        if the constant SUN is defined then the
        program is intende to run on a SUN work
        station.  This version is as non-specific
        as possible so that it should run with only
        minor modifications in other unix environments.
*/
#define IBMPC  1
/* #define SUN   1 */
/*
        There are two MSDOS versions of the program:

        if the constant BIOS is defined, then the
        program will access the RS-232 port via calls
        to the system BIOS.

        if the constant BIOS is not defined, then the
        program uses direct input/output via inport and outport.

        if the following line is not a comment, then input/output
        will be done via calls to the BIOS.
*/
/*      #define BIOS 1   */
/*
        if IBMPC is defined, then an MSDOS version is being
        generated.  In that case, if direct input/output is
        to be used, the following constants define the
        offsets from the port address for the various
        registers of the rs-232 device.
*/
#ifdef IBMPC
#include <conio.h>
#define inportb inp
#define outportb outp
#define MSC 1			/* set for Microsoft C */
#ifndef BIOS
#define txbuf  0        /* transmit buffer offset */
#define rxbuf  0        /* receiver buffer offset */
#define divlsb 0        /* divisor latch, low part */
#define divmsb 1        /* divisor latch, high part */
#define intena 1        /* interrupt enable register */
#define intid  2        /* interrupt ident. register */
#define lcreg  3        /* line control register */
#define modreg 4        /* modem control register */
#define lsreg  5        /* line status register   */
#define msreg  6        /* modem status register  */
#endif
#endif
